(function() {
  var ui = {
    green: null,
    red: null,
    pause: null,
    off: null,
    togbtn: null
  };

  var connection = -1;
    var busylightSDK = new BusylightSDK(function() {
	 	//busylightSDK.ColorRGB(0,100,0); 
	 	//enableIOControls(true);
 	} );

  var initializeWindow = function() {
    for (var k in ui) {
      var id = k.replace(/([A-Z])/, '-$1').toLowerCase();
      var element = document.getElementById(id);
      if (!element) {
        throw "Missing UI element: " + k;
      }
      ui[k] = element;
    }
    enableIOControls(false);
    ui.green.addEventListener('click', onGreenClicked);
    ui.red.addEventListener('click', onRedClicked);
    ui.pause.addEventListener('click', onPauseClicked);
    ui.off.addEventListener('click', onOffClicked);
    ui.togbtn.addEventListener('change', toggleChanged);
    
    setTimeout(function(){ togbtn.click(); }, 1000);
    
  };

  var enableIOControls = function(ioEnabled) {
    ui.green.disabled = !ioEnabled;
    ui.red.disabled = !ioEnabled;
    ui.off.disabled = !ioEnabled;
    ui.pause.disabled = !ioEnabled;
  };

  var onGreenClicked = function() {
    busylightSDK.ColorRGB(0,100,0); 
  };

  var onRedClicked = function() {
      busylightSDK.Color(BusylightColor_Red);
  };

  var onPauseClicked = function() {
    busylightSDK.Color(BusylightColor_Yellow);
  };

  var onFlashClicked = function () {
      busylightSDK.ColorWithFlash(BusylightColor_Yellow, BusylightColor_Blue);
  };

  var onOffClicked = function() {
    busylightSDK.ColorRGB(0,0,0); 
  };

  var toggleChanged= function() {
    var checkBox = document.getElementById("togbtn");
    if (checkBox.checked == true){
      onOnlineClicked();
    } else {
      onOfflineClicked();
    }
    enableIOControls(checkBox.checked)
  };

  var onOfflineClicked = function() {
    busylightSDK.ColorRGB(0,0,0); 
     chrome.storage.sync.set({'status': 'offline'}, function() {
     });
  };

  var onOnlineClicked = function() {
    busylightSDK.ColorRGB(0,100,0); 
     chrome.storage.sync.set({'status': 'online'}, function() {
     });
  };

  window.addEventListener('load', initializeWindow);

  chrome.runtime.onMessage.addListener(function(message) {
    //here you can call your popup.js function        
    window.close()
  });
}());
