var widgetstatus = 'closed';
var busylightSDK;

function startApp(){
  chrome.app.window.create(
    "control-panel.html",
    {
      id: "PuzzelBusylight", 
      singleton: true,
      innerBounds: { width: 250, height: 300, minWidth: 250 },
      state: 'minimized',
    }, function(window){
        window.onClosed.addListener(function() {
         chrome.storage.sync.set({'status': 'closed'}, function() {
          busylightSDK.ColorRGB(0,0,0); 
        });
      });
    });
}


function messageHandler(message){

   chrome.storage.sync.get(['status'], function(items) {
      widgetstatus = items.status
      if (message === "start") {
        startApp()
        busylightSDK = new BusylightSDK(function() {});
      }

       if( widgetstatus == "offline" ){
         return message;
       }
      if( widgetstatus != "online"){
        return message;
      }

      switch(message){
        case "online": //agent online - green color
            busylightSDK.ColorRGB(0,100,0); 
          break;
        case "sms":
            busylightSDK.Blink(BusylightColor_Yellow,3,5);
          break;
        case "busy": // agent busy - red color
            busylightSDK.Color(BusylightColor_Red);
          break;
        case "pause": // agent pause - yellow color
            busylightSDK.Color(BusylightColor_Yellow);
          break;
        case "call":
            busylightSDK.Color(BusylightColor_Red);
          break;
        case "blink": //social media message
            busylightSDK.Blink(BusylightColor_Yellow,3,5);
          break;
        case "alert": //sound alert
            busylightSDK.Alert(BusylightColor_Red, BusylightSoundclips.KuandoTrain, BusylightVolume.Low);
          break;
        case "pulse":
            busylightSDK.Pulse(BusylightPulseSeqence);
          break;
        case "offline": // turn off lamp
            busylightSDK.ColorRGB(0,0,0); 
          break;
        case "close":
          chrome.runtime.sendMessage({yourMsg: 'Your Msg'});
          break; 

        case "incoming enquiry": 
          busylightSDK.Blink(BusylightColor_Blue,3,5);
          break;
      }
  });
}

chrome.app.runtime.onLaunched.addListener(function() {
  startApp();
});

chrome.runtime.onMessageExternal.addListener(
  function(request, sender, sendResponse) {
    if (request && request.message) {
       messageHandler(request.message);
       sendResponse({response: widgetstatus});
    }
    return true;
});


